> elm-format-0.3.0-alpha was [announced on elm-dev](https://groups.google.com/d/msg/elm-dev/-AsbWxi2iYQ/l68u19XDCgAJ)

There are a lot of details to this release, so I'll start out with thanks to everyone who reported issues; to our new and continuing contributors @ento, @danyx23, @eeue56, and @mgold; and to the plugin maintainers @rundis, @benjick, @ajhager, and @Bogdanp.

And if you're in a hurry, here's the link: [elm-format-0.3.0-alpha downloads and installation instructions](https://github.com/avh4/elm-format#installation-)

### Elm 0.17 and 0.16 support

There are now two flavors of elm-format in each release: one for Elm 0.17, and one for Elm 0.16.  You should download the one that corresponds to the version of Elm you are using.

But note that these two flavors are **the same** except that they have different default values for the new `--elm-version` argument.  Downloading the correct flavor will make things easier for you, since your IDE plugins will work properly, but if you pass the `--elm-version` argument to elm-format, both flavors will behave identically.  (This works because elm-format can parse both 0.17 _and_ 0.16 files and can output either format regardless of which format the input was in.)

### New features
- You can migrate your Elm 0.16 code to the 0.17 syntax simply by using the 0.17 flavor of elm-format
- You can validate the formatting of files with `elm-format --validate` (useful for CI scripts)

### Changes and fixes
- 4-space indentation (see the next section)
- The first argument in function application is allowed to stay on the same line even if subsequent arguments break the line
- Decimal float and hexadecimal int literals are preserved
- The filename and line number is shown when reporting parse errors
- Added a workaround for an elm-compiler bug with escaping UTF-8 characters on Windows
- Newlines in function types are properly handled
- The commenting "trick" of having `{--}` and `--}` scattered around your file is not directly supported
- Fixes for comments
  - The contents of block comments does not indent itself further every time you format
  - Nested block comments are preserved
  - `=--` parses correctly
- top-level declarations are now spaced properly in (hopefully all) cases
- All places `=` and `:` appear in the syntax are now formatted consistently

[more details](https://github.com/avh4/elm-format/issues?utf8=%E2%9C%93&q=is%3Aissue+closed%3A2016-01-29..2016-05-11+sort%3Acreated-asc+-label%3Ainvalid+-label%3A%22won%27t+fix%22)

### 4-space indentation

We've had several discussions of indentation width in the past, but the rationale for trying 4-space indentation again is here: https://gist.github.com/avh4/bc092cc2207230d044f73defdd46fd13

elm-format has been in alpha for a long time all ready, so apologies for drawing out this issue and making another significant change.  If you have strong opinions in favor of 2-space indentation, I do want to hear them, but I would appreciate if you would first spend a few minutes considering 1) why you have those opinions, and 2) how you would convince someone holding an opposing indentation opinion.

### Next up

If you have trouble [installing elm-format to work with your editor](https://github.com/avh4/elm-format#installation-), please file an issue or make a pull request to the elm-format README.

I'm hoping the next elm-format release will be beta-quality and ready to announce on elm-discuss.  Thanks for all the feedback!
