## elm-format release plan

It's almost time for a stable release of `elm-format`, and I've been reflecting on the fact that a lot of `elm-format`'s features have benefitted from feedback from people using it on real projects (some features had to be significantly changed after seeing how they worked on real code). To allow the continued improvement of `elm-format` while still providing stability for those who need it, I've come up with the following plan:

If an `elm-format` release contains formatting changes that still need to be tested in the real world, it will be tagged as "experimental". Experimental versions will be installed with `npm install -g elm-format@exp` rather than the default `npm install -g elm-format`, and each will have a form where people can leave feedback about the experimental features.

I expect most experimental features will need about two months of feedback before a final decision about the feature can be made.

Once feedback has been collected, any failed experiments can be removed, and the next stable version of `elm-format` will be released. Addition of new formatting rules will result in a minor version bump, and changes to existing formatting rules will result in a major version bump.


## User's guide

I've started working on an `elm-format` user's guide. The goal of the guide is to document more unusual features of `elm-format` (most notably, continuous integration support) and to provide rationale for some of the more nuanced formatting choices.


## Changes in 0.7.0-exp

Experimental changes:
  - Imports are now sorted and duplicate imports are merged
  - `exposing` clauses in module headers are now sorted
  - The body of `let` expressions are no longer indented
  - Unnecessary parentheses are now removed
  - (still experimental from 0.6.1-alpha) elm-format now formats your documentation comments

You can give feedback about experimental features at <https://goo.gl/forms/kLdTN1yikfOI8ZuA3>.

Bug fixes:
  - Initial `@docs` lines in module documentation are now handled correctly
  - Formatting for lambdas with multiline patterns is now implemented
  - Code blocks in doc comments that immediately follow lists are now handled correctly

Other changes:
  - elm-format now has a contributor code of conduct


## Install

```sh
npm install -g elm-format@exp
```

or [download from the release page](https://github.com/avh4/elm-format/releases/tag/0.7.0-exp).

You can provide feedback about the experimental features at <https://goo.gl/forms/kLdTN1yikfOI8ZuA3>.


## Thanks to ...

 - @basile-henry for the initial work on import sorting
 - @mattjbray for maintaining the Arch Linux package
 - @brendanbenson for documentation fixes
