`elm-format` 0.8.0 most notably includes support for Elm 0.19 (and drops support for Elm 0.16).
This includes the `--elm-version=0.19 --upgrade` mode used by [elm-upgrade](https://github.com/avh4/elm-upgrade#elm-upgrade--)
to help automatically upgrade your code.

This version also includes the successful features from the previous experimental version of `elm-format`:

  - Imports are now sorted and duplicate imports are merged
  - `exposing` clauses in module headers are now sorted
  - The body of `let` expressions are no longer indented
  - Unnecessary parentheses are now removed (except in binary operator expressions)

For a more detailed list, see the [CHANGELOG](https://github.com/avh4/elm-format/blob/master/CHANGELOG.md#080)


## Install

```sh
npm install -g elm-format
```

or [download from the release page](https://github.com/avh4/elm-format/releases/tag/0.8.0).


## Thanks to ...

  - @harrysarson for improving the error messages
  - @robx and @alicebob for cleaning up the haskell integration tests and fixing lots of compilation warnings
  - @ahstro for fixing lots of compilation warnings
  - @tac-tics for fixing a parsing bug regarding obsolete keywords
  - many others for contribuing improvements to the README and installation instructions
